local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables
local buff = x.Buff
local talent = x.Talent

-- SpellFlash API:
-- http://wow.curseforge.com/addons/spellflash/pages/api/

-- Updated variable references:
-- http://wow.curseforge.com/addons/spellflash/pages/api/#w-local-x-spell-flash-addon-updated-variables
-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent, x.EnemyDetected, x.ShouldPermanentBuff, x.ShouldTemporaryBuff


-- Use this single spam function and remove the multiple spam table below, or just use the multiple spam table below and leave this function in place.
a.SetSpamFunction(function() a.RunSpamTable()

	x.Rage = s.Power("player", SPELL_POWER_RAGE) or 0
	x.RageMax = s.MaxPower("player", SPELL_POWER_RAGE)
	x.RageDeficit = x.RageMax - x.Rage
	x.TimeToDie = s.TimeToDie("target") or 10
	x.InCombat = s.InCombat()
	x.GCD = s.GlobalCooldown()
	x.Spec = s.TalentMastery()
	x.MaxHealth = s.MaxHealth("player")
	x.Health = s.Health("player")
	x.ActiveEnemies = s.SpellTargets()
	x.Time = s.Time()
	x.Haste = 1 + UnitSpellHaste("player") / 100
	x.MaxGCD = 1.5 / x.Haste
	if x.MaxGCD < 1 then
		x.MaxGCD = 1
	end

	if x.Spec == 1 then
		-- Arms

		s.UpdateBuff(1719--[[Battle Cry]])
		s.UpdateBuff(248625--[[Shattered Defenses]])
		s.UpdateBuff(107574--[[Avatar]])
		s.UpdateBuff(242188--[[Executioner's Precision]])
		s.UpdateBuff(152277--[[Ravager]])

		s.UpdateDebuff(208086--[[Colossus Smash]])
		s.UpdateDoT(772--[[Rend]])

		s.UpdateCooldown(1719--[[Battle Cry]])
		s.UpdateCooldown(227847--[[Bladestorm]])

		a.Flash("charge")
		a.Flash("pummel")

		a.Flash("potion,if=(!talent.avatar.enabled|buff.avatar.up)&buff.battle_cry.up&debuff.colossus_smash.up|target.time_to_die<=26",
				"blood_fury,if=buff.battle_cry.up|target.time_to_die<=16",
				"berserking,if=buff.battle_cry.up|target.time_to_die<=11",
				"arcane_torrent,if=buff.battle_cry_deadly_calm.down&rage.deficit>40&cooldown.battle_cry.remains",
--				"lights_judgment,if=buff.battle_cry.up|target.time_to_die<=11",
				"avatar,if=gcd.remains<0.25&(buff.battle_cry.up|cooldown.battle_cry.remains<15)|target.time_to_die<=20",
				"battle_cry,if=((target.time_to_die>=70|set_bonus.tier20_4pc)&((gcd.remains<=0.5&prev_gcd.1.ravager)|!talent.ravager.enabled&!gcd.remains&target.debuff.colossus_smash.remains>=5&(!cooldown.bladestorm.remains|!set_bonus.tier20_4pc)&(!talent.rend.enabled|dot.rend.remains>4)))|buff.executioners_precision.stack=2&buff.shattered_defenses.up&!gcd.remains&!set_bonus.tier20_4pc",
				"victory_rush"
--				"use_items,if=buff.battle_cry.up&debuff.colossus_smash.up"
		)

		if s.HealthPercent("target") < 20 and x.ActiveEnemies < 5 then
			-- Execute
			s.UpdateBuff(253383--[[Weighted Blade]])
			s.UpdateCooldown(12294--[[Mortal Strike]])
			a.Flash("bladestorm,if=buff.battle_cry.up&(set_bonus.tier20_4pc|equipped.the_great_storms_eye)",
					"colossus_smash,if=buff.shattered_defenses.down&(buff.battle_cry.down|(buff.executioners_precision.stack=2&(cooldown.battle_cry.remains<1|buff.battle_cry.up)))",
					"warbreaker,if=(raid_event.adds.in>90|!raid_event.adds.exists)&cooldown.mortal_strike.remains<=gcd.remains&buff.shattered_defenses.down&buff.executioners_precision.stack=2",
					-- actions.execute+=/heroic_charge,if=rage.deficit>=55&(!cooldown.heroic_leap.remains|swing.mh.remains>1.2)&buff.battle_cry.down
					--Remove the -- above to run out of melee and charge back in for rage.
					"focused_rage,if=rage.deficit<35&buff.focused_rage.stack<3",
					"rend,if=remains<5&cooldown.battle_cry.remains<2&(cooldown.bladestorm.remains<2|!set_bonus.tier20_4pc)",
					"ravager,if=cooldown.battle_cry.remains<=gcd&debuff.colossus_smash.remains>6",
					"mortal_strike,if=buff.executioners_precision.stack=2&buff.shattered_defenses.up",
					"whirlwind,if=talent.fervor_of_battle.enabled&buff.weighted_blade.stack=3&debuff.colossus_smash.up&buff.battle_cry.down",
					"overpower,if=rage<40",
					"execute,if=buff.shattered_defenses.down|rage>=40|talent.dauntless.enabled&rage>=36",
					"bladestorm,interrupt=1,if=(raid_event.adds.in>90|!raid_event.adds.exists|spell_targets.bladestorm_mh>desired_targets)&!set_bonus.tier20_4pc")
		elseif x.ActiveEnemies >= 4 then
			-- AoE
			s.UpdateBuff(225947--[[Stone Heart]])
			s.UpdateBuff(188923--[[Cleave]])
			s.UpdateBuff(248622--[[In For The Kill]])
			a.Flash("warbreaker,if=(cooldown.bladestorm.up|cooldown.bladestorm.remains<=gcd)&(cooldown.battle_cry.up|cooldown.battle_cry.remains<=gcd)",
					"bladestorm,if=buff.battle_cry.up&!talent.ravager.enabled",
					"ravager,if=talent.ravager.enabled&cooldown.battle_cry.remains<=gcd&debuff.colossus_smash.remains>6",
					"colossus_smash,if=buff.in_for_the_kill.down&talent.in_for_the_kill.enabled",
					"colossus_smash,cycle_targets=1,if=debuff.colossus_smash.down&spell_targets.whirlwind<=10",
					"cleave,if=spell_targets.whirlwind>=5",
					"whirlwind,if=spell_targets.whirlwind>=5&buff.cleave.up",
					"whirlwind,if=spell_targets.whirlwind>=7",
					"colossus_smash,if=buff.shattered_defenses.down",
					"execute,if=buff.stone_heart.react",
					"mortal_strike,if=buff.shattered_defenses.up|buff.executioners_precision.down",
					"rend,cycle_targets=1,if=remains<=duration*0.3&spell_targets.whirlwind<=3",
					"cleave",
					"whirlwind")
		elseif x.ActiveEnemies >= 2 then
			-- Cleave
			a.Flash("bladestorm,if=buff.battle_cry.up&!talent.ravager.enabled",
					"ravager,if=talent.ravager.enabled&cooldown.battle_cry.remains<=gcd&debuff.colossus_smash.remains>6",
					"colossus_smash,cycle_targets=1,if=debuff.colossus_smash.down",
					"warbreaker,if=raid_event.adds.in>90&buff.shattered_defenses.down",
					"focused_rage,if=rage.deficit<35&buff.focused_rage.stack<3",
					"rend,cycle_targets=1,if=remains<=duration*0.3",
					"mortal_strike",
					"execute",
					"cleave",
					"whirlwind")
		elseif s.HealthPercent("target") >= 20 then
			-- Single Target
			s.UpdateBuff(225947--[[Stone Heart]])
			s.UpdateBuff(188923--[[Cleave]])
			s.UpdateCooldown(167105--[[Colossus Smash]])
			a.Flash("bladestorm,if=buff.battle_cry.up&(set_bonus.tier20_4pc|equipped.the_great_storms_eye)",
					"colossus_smash,if=buff.shattered_defenses.down",
					"warbreaker,if=(raid_event.adds.in>90|!raid_event.adds.exists)&((talent.fervor_of_battle.enabled&debuff.colossus_smash.remains<gcd)|!talent.fervor_of_battle.enabled&((buff.stone_heart.up|cooldown.mortal_strike.remains<=gcd.remains)&buff.shattered_defenses.down))",
					-- actions.single+=/heroic_charge,if=rage.deficit>=55&(!cooldown.heroic_leap.remains|swing.mh.remains>1.2)&buff.battle_cry.down
					--Remove the -- above to run out of melee and charge back in for rage.
					"focused_rage,if=!buff.battle_cry_deadly_calm.up&buff.focused_rage.stack<3&!cooldown.colossus_smash.up&(rage>=130|debuff.colossus_smash.down|talent.anger_management.enabled&cooldown.battle_cry.remains<=8)",
					"rend,if=remains<=gcd.max|remains<5&cooldown.battle_cry.remains<2&(cooldown.bladestorm.remains<2|!set_bonus.tier20_4pc)",
					"ravager,if=cooldown.battle_cry.remains<=gcd&debuff.colossus_smash.remains>6",
					"execute,if=buff.stone_heart.react",
					"overpower,if=buff.battle_cry.down",
					"mortal_strike,if=buff.shattered_defenses.up|buff.executioners_precision.down",
					"rend,if=remains<=duration*0.3",
					"cleave,if=talent.fervor_of_battle.enabled&buff.cleave.down&!equipped.archavons_heavy_hand",
					"whirlwind,if=spell_targets.whirlwind>1|talent.fervor_of_battle.enabled",
					"slam,if=spell_targets.whirlwind=1&!talent.fervor_of_battle.enabled&(rage>=52|!talent.rend.enabled|!talent.ravager.enabled)",
					"overpower",
					"bladestorm,if=(raid_event.adds.in>90|!raid_event.adds.exists)&!set_bonus.tier20_4pc")
		end

	elseif x.Spec == 2 then
		-- Fury

		s.UpdateBuff(1719--[[Battle Cry]])
		s.UpdateBuff(184362--[[Enrage]])
		s.UpdateBuff(202539--[[Frenzy]])
		s.UpdateBuff(207776--[[Fujieda's Fury]])
		s.UpdateBuff(215570--[[Wrecking Ball]])
		s.UpdateBuff(85739--[[Meat Cleaver]])
		s.UpdateBuff(206316--[[Massacre]])
		s.UpdateBuff(107574--[[Avatar]])
		s.UpdateBuff(118000--[[Dragon Roar]])
		s.UpdateBuff(12292--[[Bloodbath]])

		s.UpdateCooldown(1719--[[Battle Cry]])
		s.UpdateCooldown(12292--[[Bloodbath]])
		s.UpdateCooldown(85288--[[Raging Blow]])
		s.UpdateCooldown(242553--[[Umbral Glaive Storm]])
		s.UpdateCooldown(23881--[[Bloodthirst]])

		x.CanRampage = x.Rage >= 85 or (x.Rage >= 70 and talent.carnage.enabled) or buff.massacre.up

		a.Flash("charge")
		a.Flash("pummel")

		a.Flash(-- This is mostly to prevent cooldowns from being accidentally used during movement.
--				"heroic_leap,if=movement.distance>5",
--				"heroic_leap,if=(raid_event.movement.distance>25&raid_event.movement.in>45)|!raid_event.movement.exists",
				"potion,if=buff.battle_cry.up&(buff.avatar.up|!talent.avatar.enabled)",
				"use_item,name=umbral_moonglaives,if=equipped.umbral_moonglaives&(cooldown.battle_cry.remains>gcd&cooldown.battle_cry.remains<2|cooldown.battle_cry.remains=0)",
				"avatar,if=((buff.battle_cry.remains>5|cooldown.battle_cry.remains<12)&target.time_to_die>80)|((target.time_to_die<40)&(buff.battle_cry.remains>6|cooldown.battle_cry.remains<12|(target.time_to_die<20)))",
				"battle_cry,if=gcd.remains=0&talent.reckless_abandon.enabled&!talent.bloodbath.enabled&(equipped.umbral_moonglaives&(prev_off_gcd.umbral_moonglaives|(trinket.cooldown.remains>3&trinket.cooldown.remains<90))|!equipped.umbral_moonglaives)",
				"battle_cry,if=gcd.remains=0&talent.bladestorm.enabled&(raid_event.adds.in>90|!raid_event.adds.exists|spell_targets.bladestorm_mh>desired_targets)",
				"battle_cry,if=gcd.remains=0&buff.dragon_roar.up&(cooldown.bloodthirst.remains=0|buff.enrage.remains>cooldown.bloodthirst.remains)",
				"battle_cry,if=(gcd.remains=0|gcd.remains<=0.4&prev_gcd.1.rampage)&(cooldown.bloodbath.remains=0|buff.bloodbath.up|!talent.bloodbath.enabled|(target.time_to_die<12))&(equipped.umbral_moonglaives&(prev_off_gcd.umbral_moonglaives|(trinket.cooldown.remains>3&trinket.cooldown.remains<90))|!equipped.umbral_moonglaives)",
				"bloodbath,if=buff.battle_cry.up|(target.time_to_die<14)|(cooldown.battle_cry.remains<2&prev_gcd.1.rampage)",
				"blood_fury,if=buff.battle_cry.up",
				"berserking,if=(buff.battle_cry.up&(buff.avatar.up|!talent.avatar.enabled))|(buff.battle_cry.up&target.time_to_die<40)",
				"arcane_torrent,if=rage<rage.max-40"
--				"lights_judgment,if=buff.battle_cry.up"
		)

		if a.Flash("dragon_roar,if=(equipped.convergence_of_fates&cooldown.battle_cry.remains<2)|!equipped.convergence_of_fates&(!cooldown.battle_cry.remains<=10|cooldown.battle_cry.remains<2)|(talent.bloodbath.enabled&(cooldown.bloodbath.remains<1|buff.bloodbath.up))",
				"rampage,if=cooldown.battle_cry.remains<1&cooldown.bloodbath.remains<1&target.health.pct>20",
				"furious_slash,if=talent.frenzy.enabled&(buff.frenzy.stack<3|buff.frenzy.remains<3|(cooldown.battle_cry.remains<1&buff.frenzy.remains<9))",
				"bloodthirst,if=equipped.kazzalax_fujiedas_fury&buff.fujiedas_fury.down") then
			return
		end

		if buff.battle_cry.up and x.ActiveEnemies == 1 then
			-- Cooldowns
			if a.Flash("rampage,if=buff.massacre.react&buff.enrage.remains<1",
					"bloodthirst,if=target.health.pct<20&buff.enrage.remains<1",
					"execute",
					"raging_blow,if=talent.inner_rage.enabled&buff.enrage.up",
					"rampage,if=(rage>=100&talent.frothing_berserker.enabled&!set_bonus.tier21_4pc)|set_bonus.tier21_4pc|!talent.frothing_berserker.enabled",
					"odyns_fury,if=buff.enrage.up&(cooldown.raging_blow.remains>0|!talent.inner_rage.enabled)") then
				return
			end
			a.Flash("berserker_rage,if=talent.outburst.enabled&buff.enrage.down&buff.battle_cry.up")
			if a.Flash("bloodthirst,if=(buff.enrage.remains<1&!talent.outburst.enabled)|!talent.inner_rage.enabled",
					"whirlwind,if=buff.wrecking_ball.react&buff.enrage.up",
					"raging_blow",
					"bloodthirst",
					"furious_slash") then
				return
			end
		end

		if s.HealthPercent("target") > 20 and (x.ActiveEnemies == 3 or x.ActiveEnemies == 4) then
			-- Three Targets
			s.UpdateBuff(225947--[[Stone Heart]])
			a.Flash("execute,if=buff.stone_heart.react",
					"rampage,if=buff.meat_cleaver.up&((buff.enrage.down&!talent.frothing_berserker.enabled)|(rage>=100&talent.frothing_berserker.enabled))|buff.massacre.react",
					"raging_blow,if=talent.inner_rage.enabled",
					"bloodthirst",
					"whirlwind")
		elseif x.ActiveEnemies > 4 then
			-- AoE
			a.Flash("bloodthirst,if=buff.enrage.down|rage<90",
					"bladestorm,if=buff.enrage.remains>2&(raid_event.adds.in>90|!raid_event.adds.exists|spell_targets.bladestorm_mh>desired_targets)",
					"whirlwind,if=buff.meat_cleaver.down",
					"rampage,if=buff.meat_cleaver.up&(buff.enrage.down&!talent.frothing_berserker.enabled|buff.massacre.react|rage>=100)",
					"bloodthirst",
					"whirlwind")
		elseif s.HealthPercent("target") < 20 then
			-- Execute
			s.UpdateBuff(225947--[[Stone Heart]])
			s.UpdateBuff(201009--[[Juggernaut]])
			a.Flash("bloodthirst,if=buff.fujiedas_fury.up&buff.fujiedas_fury.remains<2",
					"execute,if=artifact.juggernaut.enabled&(!buff.juggernaut.up|buff.juggernaut.remains<2)|buff.stone_heart.react",
					"furious_slash,if=talent.frenzy.enabled&buff.frenzy.remains<=2",
					"rampage,if=buff.massacre.react&buff.enrage.remains<1",
					"execute",
					"odyns_fury",
					"bloodthirst",
					"furious_slash,if=set_bonus.tier19_2pc",
					"raging_blow",
					"furious_slash")
		elseif s.HealthPercent("target") >= 20 then
			-- Single Target
			s.UpdateBuff(225947--[[Stone Heart]])
			a.Flash("bloodthirst,if=buff.fujiedas_fury.up&buff.fujiedas_fury.remains<2",
					"furious_slash,if=talent.frenzy.enabled&(buff.frenzy.down|buff.frenzy.remains<=2)",
					"raging_blow,if=buff.enrage.up&talent.inner_rage.enabled",
					"rampage,if=target.health.pct>21&(rage>=100|!talent.frothing_berserker.enabled)&(((cooldown.battle_cry.remains>5|cooldown.bloodbath.remains>5)&!talent.carnage.enabled)|((cooldown.battle_cry.remains>3|cooldown.bloodbath.remains>3)&talent.carnage.enabled))|buff.massacre.react",
					"execute,if=buff.stone_heart.react&((talent.inner_rage.enabled&cooldown.raging_blow.remains>1)|buff.enrage.up)",
					"bloodthirst",
					"furious_slash,if=set_bonus.tier19_2pc&!talent.inner_rage.enabled",
					"whirlwind,if=buff.wrecking_ball.react&buff.enrage.up",
					"whirlwind,if=!buff.meat_cleaver.up&spell_targets.whirlwind=2",
					"raging_blow",
					"furious_slash")
		end

	elseif x.Spec == 3 then
		-- Protection
		s.UpdateCooldown(23922--[[Shield Slam]])
		s.UpdateBuff(5302--[[Revenge!]])
		s.UpdateBuff(202573--[[Vengeance: Revenge]])
		s.UpdateBuff(202574--[[Vengeance: Ignore Pain]])
		s.UpdateBuff(202289--[[Renewed Fury]])
		a.Flash("auto_attack",
				"intercept",
				"blood_fury",
				"berserking",
				"pummel",
				"arcane_torrent",
				"victory_rush",
				"potion,if=target.time_to_die<25"
--				"lights_judgment"
		)
				
		a.Flash("battle_cry,if=cooldown.shield_slam.remains=0",
				"demoralizing_shout",
				"shock_wave",
				"ravager,if=talent.ravager.enabled",
				"shield_block,if=cooldown.shield_slam.remains=0",
				"ignore_pain,if=(!talent.vengeance.enabled&buff.renewed_fury.remains<1.5)|(!talent.vengeance.enabled&rage.deficit>=40)|(buff.vengeance_ignore_pain.up)|(talent.vengeance.enabled&!buff.vengeance_ignore_pain.up&!buff.vengeance_revenge.up&rage<30&!buff.revenge.react)",
				"shield_slam",
				"revenge,if=(!talent.vengeance.enabled)|(talent.vengeance.enabled&buff.revenge.react&!buff.vengeance_ignore_pain.up)|(buff.vengeance_revenge.up)|(talent.vengeance.enabled&!buff.vengeance_ignore_pain.up&!buff.vengeance_revenge.up&rage>=30)",
				"thunder_clap",
				"devastate")
	end
end)
